unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MSPpt2000, OleServer, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    PowerPointPresentation1: TPowerPointPresentation;
    PowerPointApplication1: TPowerPointApplication;
    Timer1: TTimer;
    Label1: TLabel;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    ComboBox1: TComboBox;
    ColorDialog1: TColorDialog;
    FontDialog1: TFontDialog;
    Label3: TLabel;
    Edit1: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    CheckBox1: TCheckBox;
    Button3: TButton;
    Button4: TButton;
    procedure PowerPointApplication1SlideShowBegin(Sender: TObject;
      var Wn: OleVariant);
    procedure Timer1Timer(Sender: TObject);
    procedure PowerPointApplication1SlideShowEnd(Sender: TObject;
      var Pres: OleVariant);
    procedure PowerPointApplication1SlideShowNextSlide(Sender: TObject;
      var Wn: OleVariant);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    tt,pp:integer; 
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.PowerPointApplication1SlideShowBegin(Sender: TObject;
  var Wn: OleVariant);
begin
   case Combobox1.ItemIndex of
      0:tt:=0;
      1:tt:=0;
      2:tt:=60*strtoint(Edit1.text);
   end;
   Timer1.Enabled:=True;
   self.FormStyle:=fsNormal;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   case Combobox1.ItemIndex of
      0:begin
           if (strtoint(Edit2.text)=0) or (tt=strtoint(Edit2.text)*60) then
              self.FormStyle:=fsStayOnTop;
           Label1.Caption:=TimeToStr(Now)+
               '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
           tt:=tt+1;
        end;
      1:begin
           if (tt=strtoint(Edit1.text)*60) then
              Timer1.Enabled:=false
           else
           begin
              if (strtoint(Edit2.text)=0) or (tt=strtoint(Edit2.text)*60) then
                 self.FormStyle:=fsStayOnTop;
              Label1.Caption:=formatfloat('00',tt div 60)+':'+formatfloat('00',tt mod 60)+
                  '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
              tt:=tt+1;
           end;
        end;
      2:begin
           if tt=0 then
           begin
              Timer1.Enabled:=false;
           end else
           begin
              if (tt=strtoint(Edit1.text)*60) then
                 self.FormStyle:=fsStayOnTop;
              Label1.Caption:=formatfloat('00',tt div 60)+':'+formatfloat('00',tt mod 60)+
              '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
              tt:=tt-1;
           end;
        end;
   end;

end;

procedure TForm1.PowerPointApplication1SlideShowEnd(Sender: TObject;
  var Pres: OleVariant);
begin
   Timer1.Enabled:=false;
   case Combobox1.ItemIndex of
      0:begin
           Label1.Caption:=TimeToStr(Now)+
               '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
        end;
      1:begin
           Label1.Caption:=formatfloat('00',tt div 60)+':'+formatfloat('00',tt mod 60)+
                  '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
        end;
      2:begin
           Label1.Caption:=formatfloat('00',tt div 60)+':'+formatfloat('00',tt mod 60)+
              '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
        end;
   end;
end;

procedure TForm1.PowerPointApplication1SlideShowNextSlide(Sender: TObject;
  var Wn: OleVariant);
begin
   pp:=Wn.view.slide.slidenumber;
   case Combobox1.ItemIndex of
      0:begin
           Label1.Caption:=TimeToStr(Now)+
               '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
        end;
      1:begin
           Label1.Caption:=formatfloat('00',tt div 60)+':'+formatfloat('00',tt mod 60)+
                  '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
        end;
      2:begin
           Label1.Caption:=formatfloat('00',tt div 60)+':'+formatfloat('00',tt mod 60)+
              '('+inttostr(pp)+'/'+inttostr(PowerPointPresentation1.Slides.Count)+')';
        end;
   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   if ColorDialog1.Execute then
      Label1.Color:=ColorDialog1.Color;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
   Button3.Enabled:=not CheckBox1.Checked;
   Label1.Transparent:=CheckBox1.Checked;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   if FontDialog1.Execute then
   begin
      Label1.Font:=FontDialog1.Font;
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   self.TransparentColor:=True;
   self.BorderStyle:=bsNone;
   panel1.Visible:=False;
   try
      PowerPointApplication1.Connect;
      PowerPointPresentation1.ConnectTo(PowerPointApplication1.Presentations.Item(1));
   except
      showmessage('LksWPowerpoint');
   end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
   case Combobox1.ItemIndex of
      0:Edit1.Enabled:=False;
      1:Edit1.Enabled:=True;
      2:Edit1.Enabled:=True;
   end;
end;

procedure TForm1.Label1Click(Sender: TObject);
begin
   self.TransparentColor:=False;
   self.BorderStyle:=bsSizeable;
   Panel1.Visible:=True;
   Timer1.Enabled:=False;
   try
      PowerPointPresentation1.Disconnect;
      PowerPointApplication1.Disconnect;
   except
   end;
end;

end.
